using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Pipeline.Campaign.Cqrs;

public record DeleteCampaignByIdCommand(string Id) : IRequest<bool>;

public class DeleteCampaignByIdHandler : IRequestHandler<DeleteCampaignByIdCommand, bool>
{
    private readonly AppDbContext _context;
    public DeleteCampaignByIdHandler(AppDbContext context) => _context = context;

    public async Task<bool> Handle(DeleteCampaignByIdCommand request, CancellationToken cancellationToken)
    {
        var entity = await _context.Campaign
            .FirstOrDefaultAsync(x => x.Id == request.Id, cancellationToken);

        if (entity == null) return false;

        _context.Campaign.Remove(entity);
        await _context.SaveChangesAsync(cancellationToken);
        return true;
    }
}